Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2795 2018-02-07 14:48:48Z hellstea
 ! Bugfix in computation of the anterpolation under-relaxation functions. 
 ! 
@@ -214,6 +217,9 @@
 !       routine
 ! @todo Data transfer of qc and nc is prepared but not activated
-!-------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
  MODULE pmc_interface
+
+    USE ISO_C_BINDING
+
 
 #if defined( __nopointer )
@@ -228,10 +234,10 @@
 #endif
 
-    USE control_parameters,                                                     &
-        ONLY:  air_chemistry, cloud_physics, coupling_char, dt_3d, dz, humidity,&
-               message_string, microphysics_morrison, microphysics_seifert,     &
-               nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,          &
-               nest_domain, neutral, passive_scalar, roughness_length,          &
-               simulated_time, topography, volume_flow
+    USE control_parameters,                                                    &
+        ONLY:  air_chemistry, cloud_physics, coupling_char, dt_3d, dz,         &
+               humidity, message_string, microphysics_morrison,                &
+               microphysics_seifert, nest_bound_l, nest_bound_r, nest_bound_s, &
+               nest_bound_n, nest_domain, neutral, passive_scalar,             & 
+               roughness_length, simulated_time, topography, volume_flow
 
     USE chem_modules,                                                          &
@@ -250,4 +256,7 @@
         ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nyn, nyng, nys, nysg, &
                nysv, nz, nzb, nzt, wall_flags_0
+
+    USE particle_attributes,                                                   &
+        ONLY:  particle_advection
 
     USE kinds
@@ -275,5 +284,5 @@
     USE pmc_handle_communicator,                                               &
         ONLY:  pmc_get_model_info, pmc_init_model, pmc_is_rootmodel,           &
-               pmc_no_namelist_found, pmc_parent_for_child
+               pmc_no_namelist_found, pmc_parent_for_child, m_couplers
 
     USE pmc_mpi_wrapper,                                                       &
@@ -297,60 +306,64 @@
 !
 !-- Constants
-    INTEGER(iwp), PARAMETER ::  child_to_parent = 2   !:
-    INTEGER(iwp), PARAMETER ::  parent_to_child = 1   !:
+    INTEGER(iwp), PARAMETER ::  child_to_parent = 2   !<
+    INTEGER(iwp), PARAMETER ::  parent_to_child = 1   !<
 !
 !-- Coupler setup
-    INTEGER(iwp), SAVE      ::  comm_world_nesting     !:
-    INTEGER(iwp), SAVE      ::  cpl_id  = 1            !:
-    CHARACTER(LEN=32), SAVE ::  cpl_name               !:
-    INTEGER(iwp), SAVE      ::  cpl_npe_total          !:
-    INTEGER(iwp), SAVE      ::  cpl_parent_id          !:
+    INTEGER(iwp), SAVE      ::  comm_world_nesting    !<
+    INTEGER(iwp), SAVE      ::  cpl_id  = 1           !<
+    CHARACTER(LEN=32), SAVE ::  cpl_name              !<
+    INTEGER(iwp), SAVE      ::  cpl_npe_total         !<
+    INTEGER(iwp), SAVE      ::  cpl_parent_id         !<
 !
 !-- Control parameters, will be made input parameters later
-    CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !: steering
-                                                         !: parameter for data-
-                                                         !: transfer mode
-    CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'  !: steering parameter
-                                                         !: for 1- or 2-way nesting
-
-    LOGICAL, SAVE ::  nested_run = .FALSE.  !: general switch
-
-    REAL(wp), SAVE ::  anterp_relax_length_l = -1.0_wp   !:
-    REAL(wp), SAVE ::  anterp_relax_length_r = -1.0_wp   !:
-    REAL(wp), SAVE ::  anterp_relax_length_s = -1.0_wp   !:
-    REAL(wp), SAVE ::  anterp_relax_length_n = -1.0_wp   !:
-    REAL(wp), SAVE ::  anterp_relax_length_t = -1.0_wp   !:
+    CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !< steering
+                                                         !< parameter for data-
+                                                         !< transfer mode
+    CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'  !< steering parameter
+                                                         !< for 1- or 2-way nesting
+
+    LOGICAL, SAVE ::  nested_run = .FALSE.  !< general switch
+
+    REAL(wp), SAVE ::  anterp_relax_length_l = -1.0_wp   !<
+    REAL(wp), SAVE ::  anterp_relax_length_r = -1.0_wp   !<
+    REAL(wp), SAVE ::  anterp_relax_length_s = -1.0_wp   !<
+    REAL(wp), SAVE ::  anterp_relax_length_n = -1.0_wp   !<
+    REAL(wp), SAVE ::  anterp_relax_length_t = -1.0_wp   !<
 !
 !-- Geometry
-    REAL(wp), SAVE                            ::  area_t               !:
-    REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE ::  coord_x              !:
-    REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE ::  coord_y              !:
-    REAL(wp), SAVE                            ::  lower_left_coord_x   !:
-    REAL(wp), SAVE                            ::  lower_left_coord_y   !:
+    REAL(wp), SAVE                                    ::  area_t             !<
+    REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE, PUBLIC ::  coord_x            !<
+    REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE, PUBLIC ::  coord_y            !<
+    REAL(wp), SAVE, PUBLIC                            ::  lower_left_coord_x !<
+    REAL(wp), SAVE, PUBLIC                            ::  lower_left_coord_y !<
+
 !
 !-- Child coarse data arrays
-    INTEGER(iwp), DIMENSION(5)                  ::  coarse_bound   !:
-
-    REAL(wp), SAVE                              ::  xexl           !:
-    REAL(wp), SAVE                              ::  xexr           !:
-    REAL(wp), SAVE                              ::  yexs           !:
-    REAL(wp), SAVE                              ::  yexn           !:
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_l    !:
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_n    !:
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_r    !:
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_s    !:
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !:
-
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  uc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc   !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_c  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qrc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nrc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc  !:
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sc   !:
+    INTEGER(iwp), DIMENSION(5),PUBLIC           ::  coarse_bound   !<
+
+    REAL(wp), SAVE                              ::  xexl           !<
+    REAL(wp), SAVE                              ::  xexr           !<
+    REAL(wp), SAVE                              ::  yexs           !<
+    REAL(wp), SAVE                              ::  yexn           !<
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_l    !<
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_n    !<
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_r    !<
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_s    !<
+    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !<
+
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec   !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  uc   !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vc   !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc   !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_c  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qrc  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nrc  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc  !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sc   !<
+    INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  nr_partc    !<
+    INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  part_adrc   !<
+
 
     REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c   !< child coarse data array for chemical species 
@@ -359,122 +372,144 @@
 !-- Child interpolation coefficients and child-array indices to be 
 !-- precomputed and stored.
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jco    !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jcv    !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xu   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xu   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yv   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yv   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zo   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jco    !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jcv    !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xu   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xu   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yv   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yv   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zo   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !<
 !
 !-- Child index arrays and log-ratio arrays for the log-law near-wall
 !-- corrections. These are not truly 3-D arrays but multiple 2-D arrays.
-    INTEGER(iwp), SAVE :: ncorr  !: 4th dimension of the log_ratio-arrays
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_l   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_n   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_r   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_s   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_l   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_n   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_r   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_s   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_l   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_n   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_r   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_s   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_l   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_n   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_r   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_s   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_l   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_n   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_r   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_s   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_l   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_n   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_r   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !:
+    INTEGER(iwp), SAVE :: ncorr  !< 4th dimension of the log_ratio-arrays
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_l   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_n   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_r   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_s   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_l   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_n   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_r   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_s   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_l   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_n   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_r   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_s   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_l   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_n   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_r   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_s   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_l   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_n   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_r   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_s   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_l   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_n   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_r   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !<
 !
 !-- Upper bounds for k in anterpolation.
-    INTEGER(iwp), SAVE ::  kctu   !:
-    INTEGER(iwp), SAVE ::  kctw   !:
+    INTEGER(iwp), SAVE ::  kctu   !<
+    INTEGER(iwp), SAVE ::  kctw   !<
 !
 !-- Upper bound for k in log-law correction in interpolation.
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_l   !:
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_n   !:
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_r   !:
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_s   !:
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_l   !<
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_n   !<
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_r   !<
+    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_s   !<
 !
 !-- Number of ghost nodes in coarse-grid arrays for i and j in anterpolation.
-    INTEGER(iwp), SAVE ::  nhll   !:
-    INTEGER(iwp), SAVE ::  nhlr   !:
-    INTEGER(iwp), SAVE ::  nhls   !:
-    INTEGER(iwp), SAVE ::  nhln   !:
+    INTEGER(iwp), SAVE ::  nhll   !<
+    INTEGER(iwp), SAVE ::  nhlr   !<
+    INTEGER(iwp), SAVE ::  nhls   !<
+    INTEGER(iwp), SAVE ::  nhln   !<
 !
 !-- Spatial under-relaxation coefficients for anterpolation.
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  frax   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fray   !:
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fraz   !:
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  frax   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fray   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fraz   !<
 !
 !-- Child-array indices to be precomputed and stored for anterpolation.
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflu   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuu   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflo   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuo   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflv   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuv   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflo   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuo   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflw   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuw   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflo   !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuo   !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflu   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuu   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  iflo   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ifuo   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflv   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuv   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jflo   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jfuo   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflw   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuw   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kflo   !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuo   !<
 !
 !-- Number of fine-grid nodes inside coarse-grid ij-faces
 !-- to be precomputed for anterpolation.
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_u        !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_v        !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_s        !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:)   ::  kfc_w         !:
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:)   ::  kfc_s         !:
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_u        !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_v        !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::  ijfc_s        !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:)   ::  kfc_w         !<
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:)   ::  kfc_s         !<
     
-    INTEGER(iwp), DIMENSION(3)          ::  parent_grid_info_int    !:
-    REAL(wp), DIMENSION(7)              ::  parent_grid_info_real   !:
+    INTEGER(iwp), DIMENSION(3)          ::  parent_grid_info_int    !<
+    REAL(wp), DIMENSION(7)              ::  parent_grid_info_real   !<
+    REAL(wp), DIMENSION(2)              ::  zmax_coarse             !<
 
     TYPE coarsegrid_def
-       INTEGER(iwp)                        ::  nx
-       INTEGER(iwp)                        ::  ny
-       INTEGER(iwp)                        ::  nz
-       REAL(wp)                            ::  dx
-       REAL(wp)                            ::  dy
-       REAL(wp)                            ::  dz
-       REAL(wp)                            ::  lower_left_coord_x
-       REAL(wp)                            ::  lower_left_coord_y
-       REAL(wp)                            ::  xend
-       REAL(wp)                            ::  yend
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  coord_x
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  coord_y
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzu       
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzw       
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu        
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw        
+       INTEGER(iwp)                        ::  nx                 !<
+       INTEGER(iwp)                        ::  ny                 !<
+       INTEGER(iwp)                        ::  nz                 !<
+       REAL(wp)                            ::  dx                 !<
+       REAL(wp)                            ::  dy                 !<
+       REAL(wp)                            ::  dz                 !<
+       REAL(wp)                            ::  lower_left_coord_x !<
+       REAL(wp)                            ::  lower_left_coord_y !<
+       REAL(wp)                            ::  xend               !<
+       REAL(wp)                            ::  yend               !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  coord_x            !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  coord_y            !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzu                !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzw                !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu                 !<
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw                 !<
     END TYPE coarsegrid_def
-                                          
-    TYPE(coarsegrid_def), SAVE ::  cg   !:
-
+
+    TYPE(coarsegrid_def), SAVE, PUBLIC     ::  cg   !<
+
+!-  Variables for particle coupling
+
+    TYPE, PUBLIC :: childgrid_def
+       INTEGER(iwp)                        ::  nx                   !<
+       INTEGER(iwp)                        ::  ny                   !<
+       INTEGER(iwp)                        ::  nz                   !<
+       REAL(wp)                            ::  dx                   !<
+       REAL(wp)                            ::  dy                   !<
+       REAL(wp)                            ::  dz                   !<
+       REAL(wp)                            ::  lx_coord, lx_coord_b !<
+       REAL(wp)                            ::  rx_coord, rx_coord_b !<
+       REAL(wp)                            ::  sy_coord, sy_coord_b !<
+       REAL(wp)                            ::  ny_coord, ny_coord_b !<
+       REAL(wp)                            ::  uz_coord, uz_coord_b !<
+    END TYPE childgrid_def
+
+    TYPE(childgrid_def), SAVE, ALLOCATABLE, DIMENSION(:), PUBLIC :: childgrid !<
+
+    INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: nr_part  !<
+    INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: part_adr !<
+    
     INTERFACE pmci_boundary_conds
        MODULE PROCEDURE pmci_boundary_conds
     END INTERFACE pmci_boundary_conds
-
+    
     INTERFACE pmci_check_setting_mismatches
        MODULE PROCEDURE pmci_check_setting_mismatches
@@ -509,12 +544,29 @@
     END INTERFACE
 
+    INTERFACE get_number_of_childs
+       MODULE PROCEDURE get_number_of_childs
+    END  INTERFACE get_number_of_childs
+
+    INTERFACE get_childid
+       MODULE PROCEDURE get_childid
+    END  INTERFACE get_childid
+
+    INTERFACE get_child_edges
+       MODULE PROCEDURE get_child_edges
+    END  INTERFACE get_child_edges
+
+    INTERFACE get_child_gridspacing
+       MODULE PROCEDURE get_child_gridspacing
+    END  INTERFACE get_child_gridspacing
+
+
     INTERFACE pmci_set_swaplevel
        MODULE PROCEDURE pmci_set_swaplevel
     END INTERFACE pmci_set_swaplevel
 
-    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                        &
-           anterp_relax_length_s, anterp_relax_length_n,                        &
-           anterp_relax_length_t, child_to_parent, comm_world_nesting,          &
-           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,         &
+    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                       &
+           anterp_relax_length_s, anterp_relax_length_n,                       &
+           anterp_relax_length_t, child_to_parent, comm_world_nesting,         &
+           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,        &
            parent_to_child
 
@@ -528,4 +580,6 @@
     PUBLIC pmci_synchronize
     PUBLIC pmci_set_swaplevel
+    PUBLIC get_number_of_childs, get_childid, get_child_edges, get_child_gridspacing
+
 
 
@@ -535,19 +589,19 @@
  SUBROUTINE pmci_init( world_comm )
 
-    USE control_parameters,                                                     &
+    USE control_parameters,                                                    &
         ONLY:  message_string
 
     IMPLICIT NONE
 
-    INTEGER, INTENT(OUT) ::  world_comm   !:
+    INTEGER(iwp), INTENT(OUT) ::  world_comm   !<
 
 #if defined( __parallel )
 
-    INTEGER(iwp)         ::  ierr         !:
-    INTEGER(iwp)         ::  istat        !:
-    INTEGER(iwp)         ::  pmc_status   !:
-
-
-    CALL pmc_init_model( world_comm, nesting_datatransfer_mode, nesting_mode,   &
+    INTEGER(iwp)         ::  ierr         !<
+    INTEGER(iwp)         ::  istat        !<
+    INTEGER(iwp)         ::  pmc_status   !<
+
+
+    CALL pmc_init_model( world_comm, nesting_datatransfer_mode, nesting_mode,  &
                          pmc_status )
 
@@ -564,7 +618,7 @@
 !
 !-- Check steering parameter values
-    IF ( TRIM( nesting_mode ) /= 'one-way'  .AND.                               &
-         TRIM( nesting_mode ) /= 'two-way'  .AND.                               &
-         TRIM( nesting_mode ) /= 'vertical' )                                   &                 
+    IF ( TRIM( nesting_mode ) /= 'one-way'  .AND.                              &
+         TRIM( nesting_mode ) /= 'two-way'  .AND.                              &
+         TRIM( nesting_mode ) /= 'vertical' )                                  &                 
     THEN
        message_string = 'illegal nesting mode: ' // TRIM( nesting_mode )
@@ -572,9 +626,9 @@
     ENDIF
 
-    IF ( TRIM( nesting_datatransfer_mode ) /= 'cascade'  .AND.                  &
-         TRIM( nesting_datatransfer_mode ) /= 'mixed'    .AND.                  &
-         TRIM( nesting_datatransfer_mode ) /= 'overlap' )                       &
+    IF ( TRIM( nesting_datatransfer_mode ) /= 'cascade'  .AND.                 &
+         TRIM( nesting_datatransfer_mode ) /= 'mixed'    .AND.                 &
+         TRIM( nesting_datatransfer_mode ) /= 'overlap' )                      &
     THEN
-       message_string = 'illegal nesting datatransfer mode: '                   &
+       message_string = 'illegal nesting datatransfer mode: '                  &
                         // TRIM( nesting_datatransfer_mode )
        CALL message( 'pmci_init', 'PA0418', 3, 2, 0, 6, 0 )
@@ -586,8 +640,8 @@
 !-- Get some variables required by the pmc-interface (and in some cases in the
 !-- PALM code out of the pmci) out of the pmc-core
-    CALL pmc_get_model_info( comm_world_nesting = comm_world_nesting,           &
-                             cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,    &
-                             cpl_name = cpl_name, npe_total = cpl_npe_total,    &
-                             lower_left_x = lower_left_coord_x,                 &
+    CALL pmc_get_model_info( comm_world_nesting = comm_world_nesting,          &
+                             cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,   &
+                             cpl_name = cpl_name, npe_total = cpl_npe_total,   &
+                             lower_left_x = lower_left_coord_x,                &
                              lower_left_y = lower_left_coord_y )
 !
@@ -661,40 +715,42 @@
 
     CHARACTER(LEN=32) ::  myname
-
-    INTEGER(iwp) ::  child_id         !:
-    INTEGER(iwp) ::  ierr             !:
-    INTEGER(iwp) ::  i                !:
-    INTEGER(iwp) ::  j                !:
-    INTEGER(iwp) ::  k                !:
-    INTEGER(iwp) ::  m                !:
-    INTEGER(iwp) ::  mm               !:
+    
+    INTEGER(iwp) ::  child_id         !<
+    INTEGER(iwp) ::  ierr             !<
+    INTEGER(iwp) ::  i                !<
+    INTEGER(iwp) ::  j                !<
+    INTEGER(iwp) ::  k                !<
+    INTEGER(iwp) ::  m                !<
+    INTEGER(iwp) ::  mid              !<
+    INTEGER(iwp) ::  mm               !<
     INTEGER(iwp) ::  n = 1            !< running index for chemical species
-    INTEGER(iwp) ::  nest_overlap     !:
-    INTEGER(iwp) ::  nomatch          !:
-    INTEGER(iwp) ::  nx_cl            !:
-    INTEGER(iwp) ::  ny_cl            !:
-    INTEGER(iwp) ::  nz_cl            !:
-
-    INTEGER(iwp), DIMENSION(5) ::  val    !:
-
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xl   !:
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xr   !:    
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_ys   !:
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_yn   !:
-    REAL(wp) ::  cl_height        !: 
-    REAL(wp) ::  dx_cl            !:
-    REAL(wp) ::  dy_cl            !:
-    REAL(wp) ::  left_limit       !:
-    REAL(wp) ::  north_limit      !:
-    REAL(wp) ::  right_limit      !:
-    REAL(wp) ::  south_limit      !:
-    REAL(wp) ::  xez              !:
-    REAL(wp) ::  yez              !:
-
-    REAL(wp), DIMENSION(1) ::  fval             !:
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_x   !:
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_y   !:
+    INTEGER(iwp) ::  nest_overlap     !<
+    INTEGER(iwp) ::  nomatch          !<
+    INTEGER(iwp) ::  nx_cl            !<
+    INTEGER(iwp) ::  ny_cl            !<
+    INTEGER(iwp) ::  nz_cl            !<
+
+    INTEGER(iwp), DIMENSION(5) ::  val    !<
+
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xl   !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xr   !<    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_ys   !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_yn   !<
+    REAL(wp) ::  cl_height        !< 
+    REAL(wp) ::  dx_cl            !<
+    REAL(wp) ::  dy_cl            !<
+    REAL(wp) ::  dz_cl            !<
+    REAL(wp) ::  left_limit       !<
+    REAL(wp) ::  north_limit      !<
+    REAL(wp) ::  right_limit      !<
+    REAL(wp) ::  south_limit      !<
+    REAL(wp) ::  xez              !<
+    REAL(wp) ::  yez              !<
+
+    REAL(wp), DIMENSION(5) ::  fval             !<
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_x   !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_y   !<
 
 !
@@ -709,4 +765,8 @@
        ALLOCATE( ch_yn(1:SIZE( pmc_parent_for_child ) - 1) )
     ENDIF
+    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) )  THEN
+       ALLOCATE( childgrid(1:SIZE( pmc_parent_for_child ) - 1) )
+    ENDIF
+
 !
 !-- Get coordinates from all children
@@ -719,9 +779,11 @@
           CALL pmc_recv_from_child( child_id, fval, size(fval), 0, 124, ierr )
          
-          nx_cl = val(1)
-          ny_cl = val(2)
-          dx_cl = val(4)
-          dy_cl = val(5)
+          nx_cl     = val(1)
+          ny_cl     = val(2)
+          dx_cl     = fval(3)
+          dy_cl     = fval(4)
+          dz_cl     = fval(5)
           cl_height = fval(1)
+
           nz_cl = nz
 !
@@ -734,4 +796,8 @@
              ENDIF
           ENDDO
+
+          zmax_coarse = fval(1:2)
+          cl_height   = fval(1)
+
 !    
 !--       Get absolute coordinates from the child
